Option Strict On
Option Explicit On

Imports System.IO

' This module holds subroutines to print some of the results from NAG
' G13BE and G13BJ routines
Module Printing
    Sub PrintParameters(ByVal para() As Double, ByVal sd() As Double, _
     ByVal rss As Double, ByVal objf As Double, ByVal df As Double)
        Dim i As Integer

        g13becForm.ResultsList.Items.Add("Final values of the parameters and their standard deviations")
        g13becForm.ResultsList.Items.Add("")
        g13becForm.ResultsList.Items.Add("   I                PARA               SD")
        g13becForm.ResultsList.Items.Add("")
        For i = 0 To para.GetLength(0) - 1
            g13becForm.ResultsList.Items.Add("  " & Str(i + 1) & "             " & Format(para(i), "######0.000000") & "           " & Format(sd(i), "######0.000000"))
        Next i
        g13becForm.ResultsList.Items.Add("")
        g13becForm.ResultsList.Items.Add("The residual sum of squares   =  " & Format(rss, "######0.000000"))
        g13becForm.ResultsList.Items.Add("The objective function        =  " & Format(objf, "######0.000000"))
        g13becForm.ResultsList.Items.Add("The degrees of freedom        =  " & Format(df, "######0.000000"))
        g13becForm.ResultsList.Items.Add("")
    End Sub

    Sub PrintUnivariateForecast(ByVal fva() As Double, ByVal fsd() As Double, ByVal rmsxy As Double)
        Call PrintForecast(fva, fsd)

        g13becForm.ResultsList.Items.Add("The residual mean square =  " & Format(rmsxy, "######0.000000"))
        g13becForm.ResultsList.Items.Add("")
    End Sub

    Sub PrintMultiInputForecast(ByVal fva() As Double, ByVal fsd() As Double, ByVal rmsxy() As Double)
        Call PrintForecast(fva, fsd)

        g13becForm.ResultsList.Items.Add("The residual mean square =  " & Format(rmsxy(rmsxy.GetLength(0) - 1), "######0.000000"))
        g13becForm.ResultsList.Items.Add("")
    End Sub

    Sub PrintForecast(ByVal fva() As Double, ByVal fsd() As Double)
        Dim i As Integer

        g13becForm.ResultsList.Items.Add("The forecast values and their standard errors are")
        g13becForm.ResultsList.Items.Add("")
        g13becForm.ResultsList.Items.Add("   I                FVA                 FSD")
        g13becForm.ResultsList.Items.Add("")
        For i = 0 To fva.GetLength(0) - 1
            g13becForm.ResultsList.Items.Add("  " & Str(i + 1) & "             " & Format(fva(i), "######0.000000") & "           " & Format(fsd(i), "######0.000000"))
        Next i
        g13becForm.ResultsList.Items.Add("")
    End Sub

    Sub PrintZandNoise(ByVal zt(,) As Double, ByVal noise() As Double)
        Dim l As Integer, i, j As Integer, ncol As Integer
        Dim strResult As String
        l = Math.Min(zt.GetLength(0), noise.GetLength(0))
        ncol = zt.GetLength(1)
        g13becForm.ResultsList.Items.Add("     I           NOISE             Z(T)")
        g13becForm.ResultsList.Items.Add("")
        For i = 0 To l - 1
            strResult = "    " & Str(i + 1) & "        " & Format(noise(i), "######0.000000")
            For j = 0 To ncol - 1
                strResult = strResult & "        " & Format(zt(i, j), "######0.000000")
            Next j
            g13becForm.ResultsList.Items.Add(strResult)
        Next i
    End Sub
End Module
